package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.ArContentType;
import com.izouma.awesomeadmin.service.ArContentTypeService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
*  controller类
*/
@Controller
@RequestMapping("/arContentType")
public class ArContentTypeController {

    @Autowired
    private ArContentTypeService arContentTypeService;

    /**
    * <p>获取全部记录。</p>
    */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(ArContentType record) {
        List<ArContentType> pp = arContentTypeService.getArContentTypeList(record);
        return new Result(true, pp);
    }

    /**
    * <p>根据Id。</p>
    */
    @RequestMapping(value = "/getArContentType", method = RequestMethod.GET)
    @ResponseBody
    public Result getArContentType(@RequestParam(required = false, value = "id") String id) {
        ArContentType data = arContentTypeService.getArContentTypeById(id);
        return new Result(true, data);
    }

    /**
    * <p>根据条件获取。</p>
    */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(ArContentType record) {
        ArContentType data = arContentTypeService.getArContentType(record);
        return new Result(true, data);
    }


    /**
    * <p>分页查询。</p>
    */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, ArContentType record) {
        Map<String, Object> result = new HashMap<>();

        List<ArContentType> pp =arContentTypeService.getArContentTypeByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
    * <p>保存。</p>
    */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(ArContentType record) {
        boolean num = arContentTypeService.createArContentType(record);
        if (num) {
        return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>更新信息。</p>
    */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateArContentType(ArContentType record) {
        boolean num = arContentTypeService.updateArContentType(record);
        if (num) {
        return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>删除。</p>
    */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteArContentType(ArContentType record) {

        boolean num = arContentTypeService.deleteArContentType(record);
        if (num) {
        return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
    * 导出Excel
    * @param request
    * @param response
    * @param record
    * @throws Exception
    */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, ArContentType record) throws Exception {

    List<ArContentType> arContentTypes = arContentTypeService.getArContentTypeList(record);


        String sheetName = "ar_content_type";
        String titleName = "ar类型数据表";
        String fileName = "ar类型表";
        int columnNumber = 9;
        int[] columnWidth = { 20,  20,  20,  20,  20,  20,  20,  20,  20 };
        String[] columnName = {  "" ,   "删除标识" ,   "更新时间" ,   "更新人" ,   "创建时间" ,   "创建人" ,   "名称" ,   "备注" ,   "权限"  };
        String[][] dataList = new String[arContentTypes.size()][9];

        for (int i = 0; i < arContentTypes.size(); i++) {

                        dataList[i][0] = String.valueOf(arContentTypes.get(i).getId());
                        dataList[i][1] = String.valueOf(arContentTypes.get(i).getDelFlag());
                        dataList[i][2] = String.valueOf(arContentTypes.get(i).getUpdateTime());
                        dataList[i][3] = String.valueOf(arContentTypes.get(i).getUpdateUser());
                        dataList[i][4] = String.valueOf(arContentTypes.get(i).getCreateTime());
                        dataList[i][5] = String.valueOf(arContentTypes.get(i).getCreateUser());
                        dataList[i][6] = String.valueOf(arContentTypes.get(i).getTypeName());
                        dataList[i][7] = String.valueOf(arContentTypes.get(i).getRemark());
                        dataList[i][8] = String.valueOf(arContentTypes.get(i).getPower());
                    }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
        columnNumber, columnWidth, columnName, dataList, response);


        }
    }

